`timescale 1 ns / 1 ps
module tb_iglu_multicoin_change;
  reg CLOCK, RESET, CANCEL;
  reg [2:0] COIN;
  wire ICE;
  wire [2:0] OUTCOIN;

  `include "iglu_multicoin_change_defs.v"

  // Instanz des Verkaufsautomaten
  iglu_multicoin_change UUT
    (.CLOCK(CLOCK), .RESET(RESET), .CANCEL(CANCEL),
     .COIN(COIN), .ICE(ICE), .OUTCOIN(OUTCOIN));

  // Takt
  always
    #20 CLOCK = ~CLOCK;

  // Ergebnis drucken
  initial begin
    $display ("                Zeit Reset Eisausgabe Muenzausgabe\n");
    $monitor ("%d   %d       %d           %d", $time, RESET, ICE, OUTCOIN);
  end

  // Stimuli anlegen: Muenzen eingeben
  initial begin
    CLOCK = 0; COIN = X0; CANCEL = 1'b0; RESET = 1'b1;
    #50 RESET = 1'b0;
    @(negedge CLOCK);
    // drei Fuenfziger
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    // einen Fuenfziger, dann einen Euro
    #240 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    #80 $display ("Einwurf 100 Ct"); COIN = X100; #40 COIN = X0;
    // zweimal ein Euro
    #240 $display ("Einwurf 100 Ct"); COIN = X100; #40 COIN = X0;
    #80 $display ("Einwurf 100 Ct"); COIN = X100; #40 COIN = X0;
    // einen Euro, dann einen Fuenfziger
    #320 $display ("Einwurf 100 Ct"); COIN = X100; #40 COIN = X0;
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    // zwei Euro
    #240 $display ("Einwurf 200 Ct"); COIN = X200; #40 COIN = X0;
    // 1 Euro, 1 Zwanziger, Abbruch
    #280 $display ("Einwurf 100 Ct"); COIN = X100; #40 COIN = X0;
    #80 $display ("Einwurf 20 Ct"); COIN = X20; #40 COIN = X0;
    #80 $display ("Abbruch"); CANCEL = 1'b1; #40 CANCEL = 1'b0;
    // einen Fuenziger, drei Zehner, Abbruch
    #320 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Abbruch"); CANCEL = 1'b1; #40 CANCEL = 1'b0;
    // 4 Zehner, 2 Zwanziger, ein Fuenziger (keine Rueckgabe!)
    #400 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 20 Ct"); COIN = X20; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 20 Ct"); COIN = X20; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #80 $display ("Einwurf 50 Ct"); COIN = X50; #40 COIN = X0;
    #80 $display ("Einwurf 10 Ct"); COIN = X10; #40 COIN = X0;
    #160 $stop;
  end

endmodule
